<template>
  <label
    :class="{
      [styles.field]: true,
      [styles.isDisabled]: isDisabled,
      [styles.isReadonly]: isReadonly,
    }"
    :for="id"
    :tabindex="0"
    @click="onClick"
  >
    <span
      :id="id"
      tabindex="0"
      :class="{
        [styles.box]: true,
        [styles.boxChecked]: isChecked && !isIndeterminate,
        [styles.boxIndeterminate]: isIndeterminate,
      }"
    >
      <Icon :class="styles.icon" type="check" />
    </span>
    <span
      v-if="label || $slotExists('default')"
      :class="styles.label"
    >
      <slot>
        {{ label }}
      </slot>
    </span>
  </label>
</template>

<script lang="ts">
import { Component, Emit, Prop } from 'vue-property-decorator';
import { FormField } from '@/components/form/FormField';
import Icon from '@/components/icon/Icon.vue';
import styles from './checkbox.module.scss';

@Component({
  name: 'Checkbox',
  components: { Icon },
  data: () => ({ styles }),
})
export default class Checkbox extends FormField {
    @Prop({ default: () => true })
    trueValue!: any;

    @Prop({ default: () => false })
    falseValue!: any;

    @Prop()
    isIndeterminate?: boolean;

    get isChecked() {
      return this.value === this.trueValue;
    }

    @Emit('click')
    onClick(e: Event) {
      return e;
    }
}
</script>
